/*	
	   LTR22
	    , 
	( , ,
	  -   ,
	   EEPROM )
*/

#include "stdafx.h"
#include <iostream>
#include "ltr\\include\\ltr22api.h"

using namespace std;

int TestADCStartStop(TLTR22 * module)
{
	DWORD rbuf[100];
	double rbuf2[100];
	int res=0;			
	 
	if ((res=LTR22_StartADC(module,false))==LTR_OK) //   
	{		
		if (LTR22_Recv(module, rbuf, NULL, 100, 500)==100) //  
		{				
			if ((res=LTR22_StopADC(module))==LTR_OK) //   
			{
				if ((res=LTR22_ClearBuffer(module,true))==LTR_OK) //  				
				{
					if ((res=LTR22_ProcessData(module, rbuf, rbuf2, 100, false, false, NULL))!=LTR_OK)//     
						cout<<"Error Process Data"<<res<<endl;
				}else cout<<"Error Clear buffers"<<res<<endl;
			}else cout<<"Error stop ADC"<<res<<endl;
		}else cout<<"Error Recieve ADC data"<<res<<endl;
	}else cout<<"Error start ADC"<<res<<endl;

	return res;
}


int _tmain(int argc, _TCHAR* argv[])
{		
	TLTR22* module = new TLTR22();	//    	

	int res=0;		

	memset(module,0,sizeof(TLTR22));

	res = LTR22_Close(module);

	res=LTR22_Open(module, module->Channel.saddr, module->Channel.sport, module->Channel.csn, 8);

	if (res==LTR_WARNING_MODULE_IN_USE)
	{
		cout<<"Warning Module already opened anywhere"<<endl;
		res = LTR_OK;
	}

	if (res==LTR_OK) //  
	{	
		if ((res=LTR22_IsOpened(module))!=LTR_OK) cout<<res<<endl;	
		else cout<<"Module Opened Successfull"<<endl;

		res = LTR22_SetFreq(module,false, 1);

		//    
		if ((res=LTR22_SetADCRange(module, 0, 3))!=LTR_OK) cout<<"Error set ADC Range"<<res<<endl;
		if ((res=LTR22_SetADCRange(module, 1, 2))!=LTR_OK) cout<<"Error set ADC Range"<<res<<endl;
		if ((res=LTR22_SetADCRange(module, 2, 1))!=LTR_OK) cout<<"Error set ADC Range"<<res<<endl;
		if ((res=LTR22_SetADCRange(module, 3, 0))!=LTR_OK) cout<<"Error set ADC Range"<<res<<endl;

		//    ,  ,    
		if ((res=LTR22_GetConfig(module))!=LTR_OK) cout<<"Error get Module Config"<<res<<endl;	

		//   -   
		if ((res=TestADCStartStop(module))!=LTR_OK) cout<<"Error TestStartStopTest"<<res<<endl;	
		else cout<<"Test ADC StartStop Successfull"<<endl;

		//    
		if ((res=LTR22_GetModuleDescription(module))!=LTR_OK) cout<<"Error get module Description"<<res<<endl;

		//   
		if ((res=LTR22_GetCalibrovka(module))!=LTR_OK) cout<<"Error get module Calibration"<<res<<endl;
		

		byte EEPROMData[512];
		for (int i=0;i<sizeof(EEPROMData);i++)		
			EEPROMData[i]=i;					

		//  EEPROM
		if ((res=LTR22_WriteAVREEPROM(module, EEPROMData,0,512))!=LTR_OK) cout<<"Error Write AVR EEPROM"<<res<<endl;

		memset(EEPROMData,0,sizeof(EEPROMData));

		//  EEPROM
		if ((res=LTR22_ReadAVREEPROM(module, EEPROMData,0,512))!=LTR_OK) cout<<"Error Read AVR EEPROM"<<res<<endl;

		//    
		if ((res=LTR22_Close(module))!=LTR_OK) cout<<res<<endl;
	}else cout<<"Open Module failed"<<endl;
		
	if (res==LTR_OK)cout<<"All Right -)"<<endl;
	cout<<"Enter any value and press enter"<<endl;
	cin>>res;
	return 0;
}


